#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define S second
#define F first

int cnt[30];

void solve(){
    int n;
    cin >> n;
    int a[n];
    for(int i=0; i< n; i++){
        cin >> a[i];
        for(int j=0; j< 30; j++){
            if(a[i] & (1 << j))cnt[j]++;
        }
    }
    int q;
    cin >> q;
    while(q--){
        int t;
        cin >> t;
        if(t==0){
            int k;
            cin >> k;
            int ans=0;
            for(int j=29; j>=0; j--){
                if(cnt[j]>=k){
                    ans+=1<<j;
                }
            }
            cout << ans << '\n';
        }
        else{
            int ind, val;
            cin >> ind >> val;
            ind--;
            for(int j=0; j<30; j++){
                if(a[ind] & (1<<j))cnt[j]--;
            }
            a[ind]=val;
            for(int j=0; j< 30; j++){
                if(a[ind] & (1<<j))cnt[j]++;
            }
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
}